<apex:page controller="MetadataRetrieveController" action="{!init}" sidebar="false">
    <apex:includeScript value="{!URLFOR($Resource.jszip, '/jszip.js')}"/>
    <apex:includeScript value="{!URLFOR($Resource.jszip, '/jszip-load.js')}"/>
    <apex:includeScript value="{!URLFOR($Resource.jszip, '/jszip-deflate.js')}"/>
    <apex:includeScript value="{!URLFOR($Resource.jszip, '/jszip-inflate.js')}"/>   
    <apex:form id="form" >
        <apex:sectionHeader title="Metadata Retrieve"/>
        <apex:pageMessages id="messages"/>
        <apex:actionPoller action="{!checkAsyncRequest}" interval="5" rerender="form" rendered="{!NOT(ISNULL(AsyncResult))}"/>
        <apex:pageBlock title="Layouts" rendered="{!AND(ISNULL(AsyncResult),ISNULL(MetaDataRetrieveZip))}">
            <apex:pageBlockButtons >
                <!--<apex:commandButton value="List" action="{!listMetadataItems}" /> -->
                <apex:commandButton value="Retrieve" action="{!retrieveMetadataItem}" />
            </apex:pageBlockButtons>
            <apex:pageBlockSection columns="1">
                 <apex:pageBlockSectionItem >
                    <apex:outputLabel value="ChangeSet Name" />
                    <apex:inputText value="{!changeSetName}" id="theTextInput"/>
                     </apex:pageBlockSectionItem>
                <apex:pageBlockSectionItem >
                  
                  <apex:outputLabel value="Metadata Type:" />
                    <apex:selectList size="1" value="{!MetadataType}" >
                        <apex:selectOptions value="{!MetadataTypes}"/>
                        <apex:actionSupport event="onchange"  action="{!listMetadataItems}"/> 
                    </apex:selectList> 
                </apex:pageBlockSectionItem> 
                <apex:pageBlockSection >
                    <apex:pageBlockTable columns="6" id="metadataTbl" value="{!lstCompWppr}" var="comp">
                        <apex:column > <apex:inputCheckbox value="{!comp.isSelected}"/></apex:column>
                        <apex:column headerValue="Component Name" value="{!comp.componentName}" />
                        <apex:column headerValue="API Name" value="{!comp.apiName}" />
                        <apex:column headerValue="Component Type" value="{!comp.componentType}" />
                        <apex:column headerValue="LastModifiedBy" value="{!comp.lastModifiedByName}" />
                        <apex:column headerValue="LastModifiedDate" value="{!comp.lastModifiedDate}" />
                    </apex:pageBlockTable> 
                </apex:pageBlockSection>
                <apex:pageBlockSectionItem >                    
                    <apex:outputLabel value="Metadata Item:" />
                    <apex:selectList size="10" multiselect="true"  value="{!MetaDataItem}" >
                        <apex:selectOptions value="{!MetaDataItems}"/>
                    </apex:selectList>
                </apex:pageBlockSectionItem>
            </apex:pageBlockSection>
        </apex:pageBlock>   
        <apex:outputPanel rendered="{!NOT(ISNULL(MetaDataZip))}">
            <apex:actionFunction name="metafilezip" action="{!deployZip}" rerender="form"/> 
        </apex:outputPanel>
        <apex:outputPanel rendered="{!NOT(ISNULL(MetaDataRetrieveZip))}">
            <apex:actionFunction name="receiveFile" action="{!receiveMetadataZipFile}" rerender="messages,files" oncomplete="unzip();"> 
            <!--    <apex:actionFunction name="receiveFile" action="{!receiveMetadataZipFile}" rerender="messages,files" oncomplete="createChangeSet();">-->
                <apex:param name="filename" assignTo="{!MetadataFileName}" value=""/>
                <apex:param name="filedata" assignTo="{!MetadataFileData}" value=""/>
            </apex:actionFunction>  
            <apex:actionFunction name="receiveComplete" action="{!receiveComplete}" rerender="form"/>
            <c:unzip name="unzip" oncomplete="if(more) receiveFile(path, data); else receiveComplete();">{!MetaDataRetrieveZip}</c:unzip>
        </apex:outputPanel>
        <apex:pageBlock id="files" title="Retrieved Metadata Files" rendered="{!NOT(ISNULL(MetadataFiles))}">
            <apex:pageBlockSection columns="1" >
                <apex:repeat value="{!MetadataFiles}" var="file">
                    <apex:pageBlockSectionItem >
                        <apex:outputLabel value="{!file.fullName}"/>
                        <apex:outputLabel ><pre>{!file.content}</pre></apex:outputLabel>                
                    </apex:pageBlockSectionItem>
                </apex:repeat>
            </apex:pageBlockSection>
        </apex:pageBlock>
    </apex:form>
</apex:page>